#!/usr/bin/perl

$GETONE	= 1;

$HOMEBBS	= $ENV{HOMEBBS};

#require "$HOMEBBS/lib/libFrenchy.pl"  if (!$LIB_FRENCHY) ;

$DEBUG	= 0;


sub cbreak {
}

sub cooked {
}

sub getone {
    #my $key = '';
    #cbreak();
    $term->setlflag($noecho);
    $term->setcc(VTIME, 1);
    $term->setattr($fd_stdin, TCSANOW);
    sysread(STDIN, $key, 1);
    #cooked();
    $term->setlflag($oterm);
    $term->setcc(VTIME, 0);
    $term->setattr($fd_stdin, TCSANOW);
    return $key;
}

sub get
{
    my $ch;
use POSIX;
$term     = POSIX::Termios->new();
    $fd_stdin = fileno(STDIN);

    $term->getattr($fd_stdin);
    $oterm     = $term->getlflag();

    $echo     = ECHO | ECHOK | ICANON;
    $noecho   = $oterm & ~$echo;

   if ( ( $ch = getone() ) ne "\n" )
   {
      if ( ord($ch) < 32 || ord($ch) > 126)
      {
         if ( $ch eq "" )
         {
            $ch = getone();

            if ( $ch  eq "[" )
            {
               $ch = getone();
               if ( $ch eq "A" ) # Haut - Up
               {
                  return("up");
               } # A
               elsif ($ch eq "B") # Bas - Down
               {
                  return "down";
               } # B
               elsif ($ch eq "C") # Droite - Right
               {
                  return("right");
               } # C
               elsif ($ch eq "D") # Gauche - Left
               {
                  return("left");
               } # D
               elsif ($ch eq "3")
               {
                  $ch = getone();

                  if ($ch eq "~")
                  {
                     return("supprime");
                  }
                  else
                  {
                     return("^[[3 unknown");
                  }
               } # 3
               elsif ($ch eq "2")
               {
                  $ch = getone();

                  if ($ch eq "~")
                  {
                     return("insert");
                  }
                  elsif ($ch eq "0")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F9");
                     }
                     return("^[[20~ unknown");
                  }
                  elsif ($ch eq "1")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F10");
                     }
                     return("^[[21~ unknown");
                  }
                  elsif ($ch eq "3")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F11");
                     }
                     return("^[[23~ unknown");
                  }
                  elsif ($ch eq "4")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F12");
                     }
                     return("^[[24~ unknown");
                  }
                  return("^[[2$ch Unknown");
               }
               elsif ($ch eq "5")
               {
                  $ch = getone();

                  if ($ch eq "~")
                  {
                     return("pgup");
                  }
                  else
                  {
                     return("^[[5 unknown");
                  }
               }
               elsif ($ch eq "1")
               {
                  $ch = getone();

                  if ($ch eq "~")
                  {
                     return("home");
                  }
                  elsif ($ch eq "5")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F5");
                     }
                     return("^[[15~ unknown");
                  }
                  elsif ($ch eq "7")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F6");
                     }
                     return("^[[17~ unknown");
                  }
                  elsif ($ch eq "8")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F7");
                     }
                     return("^[[18~ unknown");
                  }
                  elsif ($ch eq "9")
                  {
                     $ch = getone();

                     if ($ch eq "~")
                     {
                        return("F8");
                     }
                     return("^[[19~ unknown");
                  }
                  else
                  {
                     if ($ch eq "0")
                     {
                        $ch = getone();

                        if ($ch eq "~")
                        {
                           return("F10");
                        }
                        return("^[[10~ unknown");
                     }
                     return("^[[1$ch unknown");
                  }
               }
               elsif ($ch eq "4")
               {
                  $ch = getone();

                  if ($ch eq "~")
                  {
                     return("end");
                  }
                  else
                  {
                     return("^[[4 unknown");
                  }
               }
               elsif ($ch eq "6")
               {
                  $ch = getone();

                  if ($ch eq "~")
                  {
                     return("pgdown");
                  }
                  else
                  {
                     return("^[[6 unknown");
                  }
               }
               elsif ($ch eq "[")
               {
                   $ch = getone();
                   if ($ch eq "A")
                   { 
                      return("f1");
                   }
                   elsif ($ch eq "B")
                   {
                      return("f2");
                   }
                   elsif ($ch eq "C")
                   { 
                      return("f3");
                   }
                   elsif ($ch eq "D")
                   {
                      return("f4");
                   }
                   elsif ($ch eq "E")
                   {
                      return("f5");
                   }
                   return("^[[[");
               }
               elsif ($ch eq "P")
               {
                  return("pause");
               }
               return("^[[ unknown");
            } # [ et pas   ^[
            elsif ($ch eq "O")
            {
               $ch = getone();
               if ($ch eq "P") # F1
               {
                  return("f1");
               }
               elsif($ch eq "Q") # F2
               {
                  return("f2");
               }
               elsif ($ch eq "R") # F3
               {
                  return("f3");
               }
               elsif ($ch eq "S") # F4
               {
                  return("f4");
               }
               return("^[O unknown");
            }
         }
         elsif ( ( $ch eq "" || $ch eq "" ))
         {
            return("backspace");
         } # DELETE
         elsif( $ch eq "")
         { 
            return("refresh");
         }
         elsif ($ch eq "")
         {
            return("logout"); # CTRL +D
         }
      } # if (ord(x))
      if (ord($ch) == 9 )
      {
         return("tab");
      }
      return ("$ch");
   } # While
   return("return");
}
   
1;
