
$DEBUG	= 0;

sub input
{
   local($x, $y, $opt, $x_end, $y_end) = @_;
   local($ch, $buf) = undef;

   &i_debut;

   while ( ($ch = getc(STDIN)) ne "\n" )
   {
      if ( ord($ch) < 32 || ord($ch) > 126)
      {
         if ( $ch eq "" )
         {
            &i_escape();
         }
         elsif ( ( $ch eq "" || $ch eq "" ))
         {
            &i_backspace;
         } # DELETE
         elsif( $ch eq "")
         {
         }
         elsif ($ch eq "")
         {
            die "CTRL +D                       ";
         }
      } # if (ord(x))
      else
      {
            &i_ident_pos;
            printf $buf;
            $nb_ch++;
            &posx_add;
      }
         locate($posx, $posy);
   } # While
      &echoon;
   
      return $buf;
}
   
sub i_debut
{
   &i_in_xy($x, $y);

   $x_pos = 0;
   $y_pos = 0;
   $posx = 0;
   $posy = 0;
   $nb_ch = 0;
   undef $buf;

   &echooff;
   &i_dimension;

   $posx = $x;
   $posy = $y;
}

sub i_in_xy
{
   if (!$x || !$y)
   {
       ($x, $y) = in_xy();
   }
}

sub i_dimension
{
   if ($x_end)
   {
   }
   if ($y_end)
   {
   }
}

sub i_ident_pos
{
         if ($x_pos)
         {
            $buf = &mid($buf, 1, $nb_ch - $x_pos) . $ch . &right($buf, $x_pos);
         }
         else
         {
            $buf .= $ch;
         }
         locate($x, $y);
}

sub i_escape
{
         $ch = getc(STDIN);

         if ( $ch  eq "[" )
         {
            $ch = getc(STDIN);
            if ( $ch eq "A" ) # Haut - Up
            {
            } # A
            elsif ($ch eq "B") # Bas - Down
            {
            } # B
            elsif ($ch eq "C") # Droite - Right
            {
               if ( !($x_pos == 0) )
               {
                  printf "$DROITE";
                  &posx_add;
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf"%s,%s ", $x_pos, $posy;}
                  locate($posx, $posy);
                  $x_pos --;
               }
            } # C
            elsif ($ch eq "D") # Gauche - Left
            {
               if ( !($nb_ch <= $x_pos) )
               {
                  printf "$GAUCHE";
                  &posx_sub;
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf"%s,%s ", $x_pos, $posy;}
                  locate($posx, $posy);
                  $x_pos ++;
               }
            } # D
            elsif ($ch eq "3")
            {
               $ch = getc(STDIN);
               if ($ch eq "~")
               {
                  # Supprime

                  if ($x_pos)
                  {
                     $buf = &mid($buf, 1, ($nb_ch - $x_pos) ) . &right($buf, $x_pos -1);
                     $nb_ch--;
                     $x_pos--;
                     locate($x, $y);
                     printf "%s ", $buf;
if($DEBUG) {                     locate(1,1);}
if($DEBUG) {    printf"%s,%s ", $posx, $posy;}
                  }
               }
               else
               {
                   printf "-%s-", $ch;
               }
            } # 3
            elsif ($ch eq "[")
            {
                $ch = getc(STDIN);
                if ($ch eq "A")
                { 
                   &key_F1;
                }
                elsif ($ch eq "B")
                {
                   &key_F2;
                }
            }
         } # [ et pas   ^[
         elsif ($ch eq "O")
         {
            $ch = getc(STDIN);
            if ($ch eq "P") # F1
            {
               &key_F1;
            }
            elsif($ch eq "Q") # F2
            {
            }
            elsif ($ch eq "R") # F3
            {
            }
            elsif ($ch eq "S") # F4
            {
            }
        }
}

sub i_backspace
{
         if ( ($nb_ch - $x_pos -1 ) >= 0 )
         {
            if ($x_pos)
            {
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf "mid: %s", $x_pos;}
               $buf = &mid($buf, 1, ($nb_ch - $x_pos -1)) . &right($buf, $x_pos);
            }
            else
            {
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf "chop: %s:", $x_pos;}
               #printf("%s %s", $BACKSPACE, $BACKSPACE);
               chop ($buf);
            }

            $nb_ch--;
            &posx_sub;
            locate($x, $y);
            printf "%s ", $buf;

         }
}

sub i_refresh_line
{
         locate($x, $y);
         printf $buf;
}

sub inputn
{
    local($var);
    $var = input @_;
    printf "\n";
    return $var;
}

# Renvois les coordonnes de la position du curseur

sub inputxy
{
    local($x, $y, $opt0, $opt1, $opt2) = @_;
    local($ch, $buf);

    locate ($x, $y);
    return &input($x, $y, $opt0, $opt1, $opt2);
}

sub inputnxy
{
    local($var);
    $var = inputxy @_;
    printf "\n";
    return $var;
}

sub inputWord
{
   local($x, $y, $opt, $x_end, $y_end) = @_;
   local($ch, $buf, $space);


   $space = 1;

   &i_debut;
 
   &i_in_xy($x, $y);

   while ( ($ch = getc(STDIN)) ne "\n" )
   {
      if ( ord($ch) < 32 || ord($ch) > 126)
      {
         if ( $ch eq "" )
         {
            &i_escape();
         }
         elsif ( ( $ch eq "" || $ch eq "" ))
         {
            &i_backspace;
         } # DELETE
         elsif( $ch eq "")
         {
         }
         elsif ($ch eq "")
         {
            die "CTRL +D                       ";
         }
      }
      else
      {
         if ($space)
         {
            $space = 0;
            $ch =~ tr/a-z/A-Z/;
         }
         else
         {
            $ch =~ tr/A-Z/a-z/;
         }
         if ($ch eq " ")
         {
            $space = 1;
         }
         &i_ident_pos;
         printf "%s", $buf;
         $nb_ch++;
         &posx_add;
      }
      locate($posx, $posy);
   } # While
   &echoon;

   return $buf;
}

sub inputnWord
{
    local($var);
    $var = inputWord @_;
    printf "\n";
    return $var;
}

sub inputnDate
{
    local($var);
    $var = inputDate(@_);
    printf "\n";
    return $var;
}

sub inputDate
{
    local($x, $y, $opt) = @_;
    local($mm, $aaaa, $jj, $buf);

    if (!$x && !$y)
    {
       ($x, $y) = in_xy();
    }
   &echooff;

    $jj = inputdate_fonc(1, 31, $x, $y, 2);
    locate($x, $y);
    printf "%2d/  /", $mm;

    $mm = inputdate_fonc(1, 12, $x+3, $y, 2);
    locate($x, $y);
    printf "%2d/%2d/", $jj, $mm;

    $aaaa = inputdate_fonc(1880, 2001, $x+6, $y, 4);
    locate($x , $y);
    $buf = sprintf "%2d/%2d/%2d", $jj, $mm, $aaaa;
    printf $buf;
    return $buf;
}

sub inputdate_fonc
{
    local ($min, $max, @opt) = @_;
    local($mom);

    while ( $mom < $min || $mom > $max)
    {
       locate($x, $y);
       printf "%s", chrdup( " ", length($mom));
       locate($x, $y);
       printf "%2d/%2d/%2d", $jj, $mm, $aaaa;
       $mom = inputNum(@opt);
    }
    return $mom;
}

sub inputNum
{
   local($x, $y, $opt, $x_end, $y_end) = @_;
   local($ch, $buf, $nb_ch);


   if (!$x && !$y)
   {
      ($x, $y) = in_xy();
   }
   &echooff;
   if ($x_end)
   {
   }
   if ($y_end)
   {
   }

   locate($x, $y);

   $posx = $x;
   $posy = $y;

   &echooff;

   RETia: while ( ($ch = getc(STDIN)) ne "\n" )
   {
      if ( $ch eq "" )
      {
         $ch = getc(STDIN);

         if ( $ch  eq "[" )
         {
            $ch = getc(STDIN);
            if ( $ch eq "A" ) # Haut - Up
            {
            } # A
            elsif ($ch eq "B") # Bas - Down
            {
            } # B
            elsif ($ch eq "C") # Droite - Right
            {
            } # C
            elsif ($ch eq "D") # Gauche - Left
            {
            } # D
            elsif ($ch eq "3")
            {
               $ch = getc(STDIN);
               if ($ch eq "~")
               {
                  # Supprime
               }
               else
               {
                   printf "-%s-", $ch;
               }
            } # 3
            elsif ($ch eq "[")
            {
                $ch = getc(STDIN);
                if ($ch eq "A")
                { 
                   &key_F1;
                }
                elsif ($ch eq "B")
                {
                   &key_F2;
                }
            }
         } # [ et pas   ^[
         elsif ($ch eq "O")
         {
            $ch = getc(STDIN);
            if ($ch eq "P") # F1
            {
               &key_F1;
            }
            elsif($ch eq "Q") # F2
            {
            }
            elsif ($ch eq "R") # F3
            {
            }
            elsif ($ch eq "S") # F4
            {
            }
        }
      }
      elsif ( ( $ch eq "" || $ch eq "" ))
      {
         if ( ($nb_ch - $x_pos -1 ) >= 0 )
         {
            if ($x_pos)
            {
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf "mid: %s", $x_pos;}
               $buf = &mid($buf, 1, ($nb_ch - $x_pos -1)) . &right($buf, $x_pos);
            }
            else
            {
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf "chop: %s:", $x_pos;}
               #printf("%s %s", $BACKSPACE, $BACKSPACE);
               chop ($buf);
            }

            $nb_ch--;
            &posx_sub;
            locate($x, $y);
            printf "%s ", $buf;

         }
      } # DELETE
      elsif( $ch eq "")
      {
         locate($x, $y);
         printf $buf;
      }
      elsif ($ch eq "")
      {
         die "CTRL +D                       ";
      }
      else
      {
        if ($ch =~ /[0-9]/)
        {
         if ($x_pos)
         {
            $buf = &mid($buf, 1, $nb_ch - $x_pos) . $ch . &right($buf, $x_pos);
         }
         else
         {
            $buf .= $ch;
         }
         locate($x, $y);
         #printf "/%2s/%s/%s", mid($buf, 1, 2), mid($buf, 3, 2), mid($buf, 5, 4);
         printf $buf;
         $nb_ch++;
         if ( ($nb_ch )> $opt - 1)
         {
            last RETia;
         }
                  if ($posx == 80)
                  {
                     $posx = 1;
                     $posy ++;
                  }
                  else
                  {
                     $posx ++;
                  }
       } # [0-9];
      }
locate($posx, $posy);
   } # While
   &echoon;

   return $buf;
}

sub inputLogin
{
   local($x, $y, $opt, $x_end, $y_end) = @_;
   local($ch, $buf, $nb_ch);

   if (!$x && !$y)
   {
       ($x, $y) = in_xy();
   }
   &echooff;
   if ($x_end)
   {
   }
   if ($y_end)
   {
   }

   $posx = $x;
   $posy = $y;

   &echooff;

   while ( ($ch = getc(STDIN)) ne "\n" )
   {
      if ( $ch eq "" )
      {
         $ch = getc(STDIN);

         if ( $ch  eq "[" )
         {
            $ch = getc(STDIN);
            if ( $ch eq "A" ) # Haut - Up
            {
            } # A
            elsif ($ch eq "B") # Bas - Down
            {
            } # B
            elsif ($ch eq "C") # Droite - Right
            {
               if ( !($x_pos == 0) )
               {
                  printf "$DROITE";
                  &posx_add;
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf"%s,%s ", $x_pos, $posy;}
                  locate($posx, $posy);
                  $x_pos --;
               }
            } # C
            elsif ($ch eq "D") # Gauche - Left
            {
               if ( !($nb_ch <= $x_pos) )
               {
if($DEBUG) {      printf "$GAUCHE";}
                  &posx_sub;
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf"%s,%s ", $x_pos, $posy;}
                  locate($posx, $posy);
                  $x_pos ++;
               }
            } # D
            elsif ($ch eq "3")
            {
               $ch = getc(STDIN);
               if ($ch eq "~")
               {
                  # Supprime

                  if ($x_pos)
                  {
                     $buf = &mid($buf, 1, ($nb_ch - $x_pos) ) . &right($buf, $x_pos -1);
                     $nb_ch--;
                     $x_pos--;
                     locate($x, $y);
                     printf "%s ", $buf;
if($DEBUG) {                     locate(1,1);}
if($DEBUG) {    printf"%s,%s ", $posx, $posy;}
                  }
               }
               else
               {
                   printf "-%s-", $ch;
               }
            } # 3
            elsif ($ch eq "[")
            {
                $ch = getc(STDIN);
                if ($ch eq "A")
                { 
                   &key_F1;
                }
                elsif ($ch eq "B")
                {
                   &key_F2;
                }
            }
         } # [ et pas   ^[
         elsif ($ch eq "O")
         {
            $ch = getc(STDIN);
            if ($ch eq "P") # F1
            {
               &key_F1;
            }
            elsif($ch eq "Q") # F2
            {
            }
            elsif ($ch eq "R") # F3
            {
            }
            elsif ($ch eq "S") # F4
            {
            }
        }
      }
      elsif ( ( $ch eq "" || $ch eq "" ))
      {
         if ( ($nb_ch - $x_pos -1 ) >= 0 )
         {
            if ($x_pos)
            {
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf "mid: %s", $x_pos;}
               $buf = &mid($buf, 1, ($nb_ch - $x_pos -1)) . &right($buf, $x_pos);
            }
            else
            {
if($DEBUG) {locate(1,1);}
if($DEBUG) {printf "chop: %s:", $x_pos;}
               #printf("%s %s", $BACKSPACE, $BACKSPACE);
               chop ($buf);
            }

            $nb_ch--;
            &posx_sub;
            locate($x, $y);
            printf "%s ", $buf;

         }
      } # DELETE
      elsif( $ch eq "")
      {
         locate($x, $y);
         printf $buf;
      }
      elsif ($ch eq "")
      {
         die "CTRL +D                       ";
      }
      else
      {
        if ( !($ch eq " ") )
        {
        if ( !($ch =~ /[0-9]/ && $nb_ch == 0)  )
        {
         if (!$opt)
         {
            $ch =~ tr/A-Z/a-z/;
         }
         elsif ($opt == 1)
         {
            $ch =~ tr/a-z/A-Z/;
         }
         if ($x_pos)
         {
            $buf = &mid($buf, 1, $nb_ch - $x_pos) . $ch . &right($buf, $x_pos);
         }
         else
         {
            $buf .= $ch;
         }
         locate($x, $y);
         printf $buf;
         $nb_ch++;
         if ($posx == 80)
         {
            $posx = 1;
            $posy ++;
         }
            else
            {
               $posx ++;
            }
        }
        } # eq " "
      }
      locate($posx, $posy);
   } # While
   &echoon;

   return $buf;
}

sub inputnLogin
{
    local($var);
    $var = inputLogin @_;
    printf "\n";
    return $var;
}

1;
