#!/usr/bin/perl

# (c) Jose MANS - 15 Aout 1997.
# Version 2.2 (read CHANGES)

$TAGER	= 1;

$HOMEBBS	= $ENV{HOMEBBS};

if (-f "$HOMEBBS/lib/libFrenchy.pl" )
{
   if (! $LIB_FRENCHY)
   {
      require "$HOMEBBS/lib/libFrenchy.pl";
   }
}

require 'getopts.pl';
#require 'ctime.pl';

&Getopts('ATVHR');

# $sortie = STDOUT;

# couleur de paragraphes.
$CURRENT		= "$RESET";
$COLOR_NOM		= "$RESET$BLEU_PALE";
$COLOR_DATE		= "$RESET$GNOIR";
$COLOR_TAG		= "$RESET$ROUGE";
$COLOR_DESC		= "$RESET$VERT";
$COLOR_PPRINT		= "$RESET";
$COLOR_HR_START		= "$RESET$ROUGE";
$COLOR_HR_END		= "$RESET$ROUGE";

# Misc
$DESC_OK	= 1;
$pid		= $$;
$AREA		= "$HOMEBBS/Area";
$DESCRIBE	= ".describe";
$REPERTOIRE	= ".repertoire_name";
$NO_FILE	= ".message index.html $DESCRIBE $REPERTOIRE total .describ 00index.txt 00_index.txt";
$TOTAL		= 0;
$TYPE		= 1;
$USER		= 2;
$TAILLE		= 4;
$MOIS		= 5;
$DAY		= 6;
$ANNEE		= 7;
$NAME		= 8;

# Affichage
$LINE_MAX	= 23;  # Arret du scrolling apres la n lignes.
$COL		= 30;
$XCOL		= 50;
$TAG		= "A";

# divers
$REP	= 0;
$REP_NB_SEP	= 40;
$tagnum		= 0;
$COUNTER	= 0;

# Time US & FR
$SEP_DATE	= "/";
$FORMAT		= "FR";	# pour un format d'heures francaises placer FR
			# sinon placer US ou n'importe quoi...
$FORM_ANNEE	= 2;	# 3 pour le format 97 et 5 pour le format 1997.

%mois =("Jan", "1", "Feb", "2", "Mar", "3", "Apr", "4",
	"May", "5", "Jun", "6", "Jul", "7", "Aug", "8",
	"Sep", "9", "Oct", "10", "Nov", "11", "Dec", "12");
        # Ben quoi ? J'ai rien trouve de mieux :)


# main()


if ($opt_A)
{
   printf $CLS;
   &list_area;
}
elsif ($opt_T)
{
   &select_tager;
}
elsif ($opt_V)
{
   &down_tag;
}
elsif ($opt_H)
{
   $HTML_tager	= 1;
   $NO_tager_chdir = 1;
   &select_tager;
}
elsif ($opt_R)
{
   $RECHERCHE	= 1;
   &tager_rech;
}

# Syntaxe: &tager2("area_path");
#                     ^
sub tager2
{
    local($arg) = @_;
    undef $TAGN;
    undef $rep_num;

    if ($arg)
    {
       $arg_ok = 0;
       chdir("$arg") || ($arg_ok = 1);
    }

    if ($arg_ok == 1)
    {
printf "%s\n",$arg;
       &tager_no_found;
    }

    &nia;

    while( $rep_num >= 1 )
    {
        $rep_num--;

        eval chdir ("$rep[$rep_num]") || ($flag = $NO_DIR);
        if ($flag)
        {
            printf "dir: %s:%d", $rep[$rep_num], $rep_num;
            die ("arg!");
        }
        if ( !&nia )
        {
           chdir("..");
        }
    }

    &tager;
    `rm -f /tmp/area.* >> /dev/null`;
    &tager_exit;
}

sub select_tager
{
    local($area, $area_path, $area_lvl);

    # Si format HTML ou si une recherche doit s'effectuer sur tout
    # le disque dur!

    if ( !(-f "$HOME/$FRENCHY_A") && !$NO_tager_chdir)
    {
       printf "$AREA_SELECT";
       &x_pause;
       &tager_exit;
    }
    if (!$NO_tager_chdir)
    {
       $area = &pop_area;
       printf "$CLS$LISTE_AREA";

       if ($area)
       {
           ($area_name, $area_path, $area_lvl) = split (/\:/, $area, 9999);
           if ($area_path)
           {
              &tager2("$area_path");
           }
           &tager_no_found($area_path);
       }
       else
       {
           &tager2("$FTP_PATH");
       }
    }
    else
    {
        &tager2("$FTP_PATH");
    }
}

sub tager_no_found
{
    printf
"Desole l'area que vous souhaitez consulter est introuvable :(
Le sysop vous pris de bien vouloir l'excuser et serait heureux
de le savoir apr un mail :)


";
    &x_pause;
    &tager_exit;
}

sub tager_exit
{
    &sauve_tager;
    &dt_exit;
}

sub pop_area
{
    local ($area);
    open (ZOUT, "$HOME/$FRENCHY_REP/area.current") or die "$ERR_O_AREA";
    $area = <ZOUT>;
    close(ZOUT);
    return $area;
}

sub tager_rech
{
    printf "$TAGER_RECH";
    chop( $RECH = <STDIN> );
    $RECH =~ tr/a-z/A-Z/;

    printf "$RECH_CHOIX";
    if ($RECH)
    {
       if (&mgetcm eq "A")
       {
          &select_tager;
       }
       else
       {
          $NO_tager_chdir = 1;
          &select_tager;
       }
    }
}

sub zif
{
    local($if) = @_;
    local(@zif);

    $if  =  $_;
    $if  =~ s/\+/\\\+/g;
    $if  =~ s/\*/\\\*/g;
    $if  =~ s/\#/\\\#/g;

    @zif = split(' ', $if, 9999);
    return @zif;
}

sub nia
{
   #local($arg) = @_;
   local($retour, @var, $i, $file, @lis);

   $retour = 0;
   $pidc++;
   $file = "OUT" . $pidc;
   `$LS_N > /tmp/area.${pid}.$pidc`;

   if ($HTML_tager)
   {
      open (INDEX, ">" . "index.html");
      $sortie = INDEX;
      &tager_header;
      &table_on;
   }
   open ($file, "/tmp/area.${pid}.$pidc");

   &rep_name;

   while (<$file>)
   {
       chop($_);;
       $nia =  $_;

       @lis = split(' ', $nia, 9999);
       @zif = &zif($_);

       $i = 0;

       undef $nio;
       if ($zif[9])
       {
          for($compte = $NAME; $compte <= $#lis - 1; $compte ++)
          {
             $nio .=  $lis[$compte] . " ";
          }
          $nio .= $lis[$compte];
          $lis[$NAME] = $nio;
       }
       if ($i == ${REP})
       {
          $_ = $zif[$i];
          if ( /^d/ ) # Repertoire
          {
             if ( !($zif[$NAME] eq ".." || $zif[$NAME] eq ".") )
             {
                $pwd = `${PWD_CMD}`;
                chop($pwd);
                $rep[$rep_num] = $pwd . "/". $lis[$NAME]; # . "/"; # . $REPERTOIRE;
                $retour = 1;

                if ($HTML_tager)
                {
                   $var[1] = &pdate(*lis);
                   printf $sortie <<"END_HTML";
                <TR>
                <TD VALIGN=top>
                <P><FONT SIZE="+1"><A HREF="$lis[$NAME]/index.html">$lis[$NAME]</A>
                </FONT>
                </TD><TD VALIGN=top WIDTH=80>
                <P ALIGN=RIGHT><FONT SIZE="+0">Repertoire</FONT>
                </TD><TD VALIGN=TOP WIDTH="60">
                <P><FONT SIZE="+0">$var[1]</FONT>
                </TD><TD VALIGN=TOP>
                <P><FONT SIZE="+0"><PRE>

END_HTML
                   &pcat("$rep[$rep_num]" . "/" . "$REPERTOIRE");
                   printf $sortie <<END_HTML;
                </PRE></FONT> </TD></TR>

END_HTML
                } # HTML_tager
                $rep_num++;
             }
          } # Repertoire
          else
          {
             if (/^l/)
             {
                # Gestion des liens
             }
             else
             {
                # Je control que les noms de fichier contenus dans $NO_FILE
                # ne soit pas traites!

                $_ = ${NO_FILE};
                if ( /$zif[0]/ || /$zif[$NAME]/ || $zif[$NAME] eq "" )
                {
                   # hehee :)
                }
                else
                {
                   if ($RECHERCHE)
                   {
                      if ( &t_rech("$zif[$NAME]", "$RECH") || &t_rech2)
                      {
                         &tager_aff;
                      }
                   }
                   else
                   {
                      &tager_aff;
                   } # RECHERCHE
                } # NO_FILE
             } # IF Gestion des liens
           }
       } #if REP

       $i++;
   } #while $file

   if($HTML_tager)
   {
      &table_off
   }

   if ($HTML_tager)
   {
      &tager_trailer;
      close($sortie);
   }

   close($file);
   `rm -rf /tmp/area.${pid}.$pidc`;
   $pidc--;

   return $retour;

} #sub nia

sub pprintf
{
    local($var, @ta) = @_;
    local($choix, $ret, $vor);

    $ret = 0;
    if (!$sortie)
    {
       $sortie = STDOUT;
    }
    printf $sortie "%s", $var;

    $vor = $var;
    while ($vor =~ s/\n//) { $ret ++}
    #$rot = split (/\n/, $var, 9999);

    undef $vor;

    if (!$HTML_tager)
    {
     if ( $ret >= 1)
     {
       $COUNTER = $COUNTER + $ret ;
       #$COUNTER = $COUNTER + $ret -1;
       if ($COUNTER >= $LINE_MAX)
       {
          printf $sortie "$RESET$COLOR_PPRINT";
          printf $sortie "$PPRINTF_GET";
          #chop($choix = <STDIN>);
          $choix = &mgetc;
          #$choix = split (/:/, $choix, 9999);
          $choix =~ tr/a-z/A-Z/;
          printf $sortie "$RESET\n";
          #if (/TCVS/ =~ $choix)
          #if ($choix =~ /TCVS/)
          #$_ = $choix;
          #if (/TCVS/)
         {

          if ($choix eq "T")
          {
             &tager;
          }
          elsif ($choix eq "C")
          {
             # On continue!
          }
          elsif ($choix eq "S")
          {
              #if (&sauve_tager())
              #{
                 &tager_exit;
              #}
          }
          elsif ($choix eq "V")
          {
              &voir;
          }
         } # If option
          $COUNTER = 0;
          pprintf ("\n");
          if (!$HTML_tager)
          {
             color("");
          }
       }
     }
  } # HTML_tager
}

sub tager_aff
{
                      if (!$HTML_tager)
                      {
                         &color("$COLOR_TAG");
                         pprintf (sprintf "%s ", $TAG);
                         &color("$COLOR_NOM");
                         pprintf (sprintf "%-29s ", &left($lis[$NAME], 32));
                         &color("$COLOR_DATE");
                         $download{$TAG} = `${PWD_CMD}`;
                         chop($download{$TAG} );
                         $download{$TAG} = $download{$TAG} ."/". $lis[$NAME];
                         if ($TAG eq "Z")
                         {
                            $TAG = "A";
                         }
                         else
                         {
                            $TAG++;
                         }
                         pprintf (sprintf "%####5dKo " , &ptaille(*lis));
                         pprintf (sprintf "%-8s " , &pdate(*lis));
                         #pprintf (" ");
                         &describ("$lis[$NAME]");
                         &puser(*lis);
                         &br;
                      }
                      else
                      {
                         # Ici on pond du HTML :)

                         $var[0] = &left($lis[$NAME], 32);
                         $var[1] = sprintf "%####5dKo " , &ptaille(*lis);
                         $var[2] = &pdate(*lis);
                         printf $sortie <<"END_HTML";
                         <TR>
                         <TD VALIGN=top>
                         <P><FONT SIZE="+1"><A HREF="$var[0]">$var[0]</A>
                         </FONT>
                         </TD><TD VALIGN=top WIDTH=80>
                         <P ALIGN=RIGHT><FONT SIZE="+0">$var[1]</FONT>
                         </TD><TD VALIGN=TOP WIDTH="60">
                         <P><FONT SIZE="+0">$var[2]</FONT>
                         </TD><TD VALIGN=TOP>
                         <P><FONT SIZE="+0">

END_HTML
                         &describ("$lis[$NAME]");
                         printf $sortie <<END_HTML;
                         </FONT> </TD></TR>

END_HTML

                      } # HTML_tager
}

sub table_on
{
    printf $sortie <<"HTML_END";
<TABLE BORDER=0 CELLSPACING=9 CELLPADDING=9 VALIGN=TOP>

HTML_END
}

sub table_off
{
    printf $sortie <<"HTML_END";
</TABLE></P>

HTML_END
}

sub tager_header
{
    printf $sortie <<"HTML_END";
<HTML>
 <HEAD>
  <TITLE> ${HTML_TITLE}
  </TITLE>
</HEAD>
<BODY BACKGROUND="${HTML_BG}">

HTML_END
}

sub tager_trailer
{

      printf $sortie <<"HTML_END";

<BODY> <HTML>

HTML_END
}

sub tager
{
    local($choix, $nia, $i, $chichi);

    if (!$HTML_tager)
    {
    printf"$TAGER_GET";
    #chop($choix = <STDIN>);

    while ( ($choix = &mgetcem) ne "\n")
    {
        if ($choix =~ /[A-${TAG}]/ )
        {
           $chichi = $choix . "," . $chichi;
           printf "%s, ", $choix;
        }
    }
       $choix = $chichi;
       $choix = &no_space($choix);
       $nia_num = @nia = split (/\,/, $choix, 9999);
       #$nia_num = split (/\,/, $choix, 9999);
       for ($i = $nia_num; $i >= 0; $i--)
       {
          if ( $nia[$i] =~ /[A-Z]/ )
          {
             $tag[$tagnum] = $download{$nia[$i]};
             $tagnum++;
          }
       }
    } # If HTML_tager
}

sub sauve_tager
{
    if ($tagnum)
    {
       &config;
       open (OUT, ">" . "$HOME/$FRENCHYTAG") or die "$ERR_SAUVE_TAGER";

       $tagnum--;
       for ($i = $tagnum;  $i >= 0 ; $i--)
       {
           printf OUT "%s\n", $tag[$i];
       }
       close OUT;
    }
    return 1; # On qui le programme
}

sub down_tag
{
    open (OUT, "$HOME" . "/". "$FRENCHYTAG") or ($flag = 1);
    close OUT;
    if ($flag)
    {
       printf"$CLS";
       printf "$DL_NO_FILE";
       &x_pause;
       return 1;
    }
    printf "$DL_INFO_DL";
    &x_open("$PROTOCOLS");
}

sub verif_tag
{
    local (@zif, @lis, $a_down);

    open(LINE, "$HOME/$FRENCHYTAG") or die 'frenchytag no found';

    printf "$DL_GET";
    while(<LINE>)
    {
       if ($_)
       {
          chop($_);
          @lis = &ls("$_");
          printf "${VERT}%8s %s$RESET", $lis[$TAILLE], $lis[$NAME];
          if ($lis[$NAME])
          {
             printf "${VIOLET} (${JAUNE}O${VIOLET}/n) : ";
             $choix = &mgetcem;
             if ($choix eq "$OUI" || $choix eq "\n")
             {
                 printf "%s ", $OUI;
                 $a_down = $a_down . " " . $_;
                 printf "  ${GRAS}Ok! $RESET";
             }
             else
             {
                printf "%s", $NON;
             }
             printf("$RESET\n");
          }
       }
    }
    return $a_down;
}

sub voir
{
    local($choix, $buf);
    printf"$VOIR_GET";
    #chop($choix = <STDIN>);
    $choix = &mgetc;
    $choix =~ tr/a-z/A-Z/;
    if ( $choix =~ /[A-Z]/ )
    {
       $buf = sprintf "less -E %s", $download{$choix};
       system $buf;
       &x_pause;
    }
}

sub puser
{
    local(*import) = @_;
    local($var, $gcos);
    if ( !( $SYSTEM_USER =~ $import[$USER]) )
    {
       $gcos = (getpwnam($import[$USER]))[6];
       ($var) = split (/\,/, $gcos, 2);
       pprintf(sprintf "\n%-${XCOL}s${AMBRE}upload: ${CURRENT}%s\n", " ", $var);
       return $var;
    }
}
sub ptaille
{
    local(*import) = @_;
    local($taille);
    $taille = $import[$TAILLE] / 1024;
    return $taille;
}

sub rep_debut
{
   if ($HTML_tager)
   {
      printf $sortie <<"HTML_END";
<CENTER>
<FONT SIZE=4>
HTML_END
   }
    &color("$COLOR_HR_START");
    &hr("-", $REP_NB_SEP);
    pprintf"\n";
}

sub rep_fin
{
   if ($HTML_tager)
   {
      printf $sortie <<"HTML_END";
</FONT></CENTER>

HTML_END
   }
   &color("$COLOR_HR_END");
   &hr("-", $REP_NB_SEP);
   pprintf"\n";
   &br;
}

sub rep_name
{
    local($desc);
    $desc=0;

    open(REP, "$REPERTOIRE" ) || ($desc = 1);
    if ($DESC_OK)
    {
       &rep_debut;
       if (!$desc)
       {
          if (!$HTML_tager)
          {
             &color("$GRIS");
          }
          while (<REP>)
          {
              pprintf (sprintf"%s", $_);
          }
          if (!$HTML_tager)
          {
             &color("");
          }
        }
        else
        {
          chop($pwd = `${PWD_CMD}`);
          $pwd =~ s/${FTP_PATH}//;

          pprintf (sprintf"%s\n", $pwd);
        }
        &rep_fin;
    }
}

sub hr
{
    local($var, $nb) = @_;

    if ($HTML_tager)
    {
       printf $sortie <<"HTML_END";

       <HR WIDTH="$nb%">
HTML_END
    } else
    {
       for($i=0; $i <= $nb; $i++)
       {
          pprintf "$var";
       }
    }
}

sub describ
{
    local($var) = @_;
    local($desc, $describ, $trouve, @nia, $trouve);
    $describ = 0;
    $trouve = 0;

    if (!$HTML_tager)
    {
       &color("$COLOR_DESC");
    }

    open(DESCRIBE, "$DESCRIBE") || ($desc = 1);
    if ($desc)
    {
       pprintf "$DESC_NO";
       if (!$HTML_tager)
       {
          &color("");
       }
       return $ret;
    }
    RETa: while (<DESCRIBE>)
    {
       if (/^${var}/)
       {
          @nia = split (/\t/);
          &pleft($nia[1], $XCOL, $COL);
          if (!$HTML_tager)
          {
             &color("$RESET");
          }
          $trouve = 1;
          last RETa;
       }
     }
     if ( !$trouve )
     {
        pprintf "$DESC_NO";
        if (!$HTML_tager)
        {
           &color("$RESET");
        }
     }
     close(DESCRIBE);
     return;
}      

sub t_rech
{
    local($var, $vor) = @_;
    local($desc, $trouve, @nia);

    open(DESCRIBE, "$DESCRIBE") || ($desc = 1);
    if ($desc)
    {
       return;
    }
    RETa: while (<DESCRIBE>)
    {
       @nia = split (/\t/, $_, 2);

       if ($var eq "$nia[0]")
       {
          $nia[1] =~ tr/a-z/A-Z/;

          if ($nia[1] =~ /$RECH/)
          {
             return 1;
          }
       }
     }
}

sub t_rech2
{
    $flag = 0;
    foreach $_ (@lis) {
        $sauve = $_;
        tr/a-z/A-Z/;
        if (/${RECH}/)
        {
           $flag = 1;
        }
        $_ = $sauve;
    }
    return $flag;
}

sub pdate
{
    local(*import) = @_;
    local($var, $nmois, $njour, $annee);

    $nmois = "0" . "$mois{$import[$MOIS]}";
    $njour = "0" . "$import[$DAY]";

    $var = length($import[$ANNEE]);

    if ( $var == 4)
    {
       $annee = &right($import[$ANNEE], $FORM_ANNEE);
    }
    else
    {
       $var = ctime(time());
       chop($var);
       $annee = &right($var, $FORM_ANNEE);
    }
    if($FORMAT == "FR")
    {
       # JJ/MM/AA[AA]
       $renvoi = &right($njour, 2) . "$SEP_DATE" . &right($nmois, 2) . "$SEP_DATE" . $annee;
    }
    else
    {
       # MM/DD/YY Format US!
       $renvoi = &right($nmois, 2) . "$SEP_DATE" . &right($njour, 2) . "$SEP_DATE" . $annee;
    }
    return ($renvoi);
}



##################################
# Affiche les Areas, repertoire. #
##################################
sub list_area
{

    #local($area_niv, $area_rep, @area);

    if ( !(-f "$AREA") )
    {
       &no_area();
    }
    open (AREA, "$AREA");

    $NULL = <AREA>;
    while(<AREA>)
    {
       $o++;
       ($area[$o], $area_rep[$o], $area_niv[$o]) = split( /:/, $_, 99);
       if ($L_USER >= $area_niv[$o] )
       {
          $SCROLL++;
          &color("$RESET${BLEU_PALE}");
          printf "%2d ", $o;
          &color("${GBLEU_PALE}");
          printf"%s\n", $area[$o];
       }
       elsif ($L_USER <= $read_ok)
       {
          $SCROLL++;
          &color("$RESET${BLEU_PALE}");
          printf "%2d ", $o;
          printf"%s\n", $area[$o];
       }

       if ( $SCROLL >= $LINE_MAX)
       {
          &area_q;
       }
    }
    close(AREA);
    &area_q;
    printf"$RESET";
}

sub area_q
{
$HOME           = $ENV{HOME};

    printf"\n";
    $SCROLL = 0;
    printf"$RESET";
    printf"$AREA_GET";
    chop($choix = <STDIN>);
    $choix =~ tr/a-z/A-Z/;
    if ($choix >= 1 && $choix <= $o)
    {
       if ($L_USER < $area_niv[$choix])
       {
          printf $LEVEL_BAS;
          &x_pause;
          &exit;
       }
       &area_save;
       &dt_exit; # Monsieur a choisit :)
    }
    elsif ($choix eq "S")
    {
       #&area_save;
       &dt_exit;
    }
    &color("");
    printf"\n";
}

sub dt_exit
{
    `rm -f /tmp/area.* > /dev/null`;
    exit;
}

sub area_save
{
    &config;
    open(YOUT, ">" . "$HOME/$FRENCHY_REP/area.current");
    printf YOUT "%s:%s:%s", $area[$choix], $area_rep[$choix], $area_niv[$choix];
    close YOUT;
    return ("1");
}

sub aff_area
{
    printf "%s [ ${AMBRE}%-20s${RESET} ]\n", $AREA_AFF, split (/\:/, &pop_area, 9);
}


# Fonctions :
# HTML Version tager.

sub br
{
    local($var) =@_;
    local($i);
    for($i=0; $i <= $var; $i++)
    {
       pprintf "\n";
    }
}

sub ul
{
    local($var) = @_;
    pprintf"%s", $var;
}

#
# Misc
sub pleft
{
   local($var, $XCOL, $COL) = @_;
   local($a, @i, $nio);

   undef $nio;
   $var =~ s/\n/ /g;            # On elimine les LF (retour chariot)

   while ($var =~ s/  / /g) {}  # On elimine tous les doubles espaces!
   @i = split (/ /, $var, 9999);
   $rest = $COL;
   # On compte les mots pouvant rentrer dans une ligne dimentionnee par
   # $COL

   RETe: while()
   {
       $num = length($i[$a]) + 1;
       if ( $num >= $rest)
       {
          pprintf (sprintf"%s\n", $nio);
          pprintf (sprintf"%-${XCOL}s%s", ' ', $i[$a]);
          $nio = "";
          $rest = $COL;
          $mot = 0;
          $debut = $a;
       }
       else
       {
          $nio = $nio . " " . $i[$a];
       }
       $rest = $rest - $num;
       $mot++;
       if ($a >= $#i)
       {
          last RETe;
       }
       $a++;
   }
   pprintf (sprintf"%s\n", $nio);
   pprintf "\n";
}

sub area_no
{
    if ( !(-f "$AREA") )
    {
       printf "$AREA_NO";
       &x_pause;
    }
}

1;
