#!/usr/bin/perl

$HOMEBBS	= $ENV{HOMEBBS};

require "$HOMEBBS/lib/libFrenchy.pl";
require "$HOMEBBS/lib/lib_unistdmans.pl";
require "$HOMEBBS/lib/input.pl";

   &echooff;

$tty_list	= "tty1 tty2 tty3 tty4";
@tty_list	= split (/ /, $tty_list, 9999);


$SIG{'USR1'} = 'talk_sysop';
$SIG{'INT'}	= 'clean';
$SIG{'HUP'}	= 'clean';


$idle_sysop_max	= 3;

if ($BEST_IDLE)
{
    $idle = &calcul_best_idle(@tty_list);

    if ( $idle >= $idle_sysop_max )
    {
       &pas_la;
    }
}
    &motif;

    &toctoc;

    &appel_sysop;

    &pas_la;


sub motif
{
    cat("$HOMEBBS/chat_motif.ans");
    locate(10,11);
    $motif = &inputxy(11,10);
}

sub toctoc
{
    cat("$HOMEBBS/chat_toctoc_sysop.ans");
    echo("$BEEP$BEEP$BEEP$BEEP$BEEP$BEEP\n", "/dev/beep");
    cat("$HOMEBBS/sounds/chat_toctoc.au", "$AUDIO1");
}

sub appel_sysop
{
    cat ("$HOMEBBS/chat_request.txt", "$TALK_TTY");
    echo("Pour motif: $motif\n", "/dev/tty1");
    #system("write /dev/tty1 < chat_request.txt 2> /dev/null&");

       &echooff;
    for ($i = 0 ; $i <= $attente_de_reponse_sysop ; $i ++)
    {
       sleep 1;
       locate (34, 9);
       printf "$GRAS$VERT%2d seconds\n", $attente_de_reponse_sysop - $i;
    }
}

sub pas_la
{
   # Le sysop est pas la ou ne peut repondre.
   cat("$HOMEBBS/chat_pas_la.ans");

   locate(13,61);
   $choix = mgetcm();

   &echoon;

   if ( ($choix eq $NON) )
   {
       exit 1; # ou exit;
   }
   exec "$MAILER $SYSOP";
}

sub calcul_best_idle
{
    local(@tty_list) = @_;
    local($tty, $idle_tmp, $idle);

    $idle_tmp	= -1;

    foreach $tty (@tty_list)
    {
       $idle = getidle("/dev/$tty");

       if ($idle_tmp < 0)
       {
          $idle_tmp = $idle;
       }
       else
       {
          if ($idle <= $idle_tmp )
          { 
             $idle_tmp = $idle;
          }
       }
    }
    return $idle_tmp;
} # Calcul_best_idle

sub talk_sysop
{
    &echoon;
    system ("talk $TALK_USER");
    exit;
}

sub clean
{
    &echoon;
    exit;
}

1;
