#!/usr/bin/perl

# Jose Mans (c) 1996,1997,1998
# v2.1 22 Juillet 1998

$HOMEBBS	= $ENV{HOMEBBS};

require 'ctime.pl';
require "${HOMEBBS}/lib/libFrenchy.pl";
require "ppp";

$login	= "mans";
$passwd	= "jose";
$prenom="Jose";
$nom = "Mans";


$HTML_mots_clef	= "DEBUT";
$PAGE_USER  = "${HOMEWWW}/no_page.html";


$QUESTION	= ${VERT};
$MESSAGE	= ${AMBRE};
$MESSAGE2	= ${RESET} . ${VERT};


# Sub-fonction

sub merci
{
    printf"$CLS ${AMBRE}
Merci d'avoir repondu au questionnaire qui a permis
votre inscription sur le BBS Gyptis

Maintenant vous allez acceder a certain nombre de
possibilites sur le serveur. Ceci dit , pour augmenter
votre niveau il faudra se presenter dans la conference 
\"presentation\" : option M, puis N du menu principal.


Appuyez sur ENTREE pour acceder a votre Menu principal!!
${RESET}";

    $_ = <STDIN>;
}

sub mail_sysop
{
    system("mail sysop -s NewsUser \< newuser.rep");
}

sub mail_all
{
    system("mail all -s \'Nouvel utilisateur\' \< newuser.all");
}

sub news_all
{
    system("inews  -n \"${GROUP_NEW}\" -t \"Nouvel utilsiateur sur ${NAME_BBS}\" -f \"${MOULINEX} (Vigilant Automate)\" -S newuser.all");
}

sub mail_welcome
{
    $buf = sprintf "(mail -s Bienvenu! $login < ${HOMEBBS}/new/mail.welcome)";
    system "$buf";
}

#########################################
# Enregistrement dans le fichier passwd #
#########################################

sub save_enregistrement
{
    open(OUT , ">${TEMPFILE}");

    printf OUT "Nom et Prenom: %s\n", $nom;
    printf OUT "Date de naissance: %s\n", $date_nee;
    printf OUT "Login: %s\n", $login;
#    if ($PPP_OK)
#    {
#       printf OUT "lLogin PPP: P%s ; il a pris un acces PPP!\n", $login;
#    } else {
#              printf OUT "Login PPP: Il veut pas d'acces PPP, mais je l'enregistre dans la base : /etc/ppp/pap-secrets\n";
#           }
    printf OUT "Password: %s\n", $verifpass;
    printf OUT "Email : %s\n", $EMAIL;
    printf OUT "Tel: %s\n", $tel;
    printf OUT "Fax: %s\n", $fax;
    printf OUT "Adresse1: %s\n", $adresse1;
    printf OUT "Adresse2: %s\n", $adresse2;
    printf OUT "Ville: %s\n", $ville;
    printf OUT "Code postal: %s\n", $cpostal;
    printf OUT "Nom du departement: %s\n", $departement;


    close(OUT);

# Ici on evois le Nom, date de neessance et login aux utilisateurs ayant
# le droit d'avoir une tel information. Sur Gyptis on consdfere que tous
# le monde peut le savoir puisque le meme monde peut consulter le fichier
# /etc/passwd.  D'autre part cela simplifie la vie du mondes en leurs
# evitent de le faire pendant une connexion :)

    if ($MAIL_ALL)
    {
       open(OUT , ">${TEMPFILE_ALL}");

       printf OUT "
Cher utilisateurs!  Nouveau connecte sur Gyptis, 

Voici les renseignement sur cette personne :

Il ou elle se nomme : 	%s\n", $nom;
       printf OUT "Et ne(e)	%s\n", $date_nee;
       printf OUT "Reste accessible  l'adresse :	%s\@$DOMAIN\n", $login;

       if ($PPP_OK)
       {
          printf OUT "Et a pris l'acces PPP!";
       } else {
                  printf OUT "Il veut pas d'acces PPP, mais je l'enregistre dans la base : /etc/ppp/pap-secrets\n";
              }
        printf OUT "

Habite dans le departement: %s

Ecrivez-lui :)


Au revoir!
", $departement;

       close(OUT);
     }

# On envois le message :

        if ($MAIL_ALL == 1)
        {
           if ($MAJORDOMO)
           {
              &mail_all;
           }
           else
           {
              system("mail -s \"Nouvel utilsiateur \
                      sur $BBS_NAME\" /usr/spool/mail/* < newuser.all");
           }
        }
        elsif ($MAIL_ALL == 2)
        {
           &news_all;
        }
        printf"Enregistrement dans la mailing-list de Gyptis\n";
        open(OUT , ">>" . "${LISTE_GYPTIS}");

        printf OUT "%s\@%s\n", $login, $DOMAIN;
        close (OUT);
        sleep 1;


    printf "Enregistrement de votre fiche d'enregistrement\n";
    $buf = sprintf "cp %s ${HOMEBBS}/fiches_users/%s", $TEMPFILE, $login;
    system $buf;
}

#######################################################
# Enregistrement dans le fichier /etc/ppp/pap-secrets #
#######################################################

sub save_pap
{

    open(OUT , ">>" . "${PAP_FILE}");

    printf OUT "%s\t\*\t%s\t\t\t%s\n", $login, $verifpass, ${IP_GUEST};
    printf OUT "P%s\t\*\t%s\t\t\t%s\n", $login, $verifpass, ${IP_GUEST};

    close (OUT);
}

sub len_pass
{
    if ($len < 5 || $len > 10)
    {
       printf"

   ${CLIGNO}YouYou ! ${RESET}${MESSAGE}On a dit entre 5 a 10 lettres !
   et pas un mot de pass avec $len lettres !

   Merci de bien vouloir recomencer!
" ;
       return 1;
    }
}

#############
# Acces PPP #
#############

sub acces_ppp
{
printf "${AMBRE}

             ------------
${MESSAGE}
###################################
# Message de derniere minutes ... #
###################################
";

sleep(1);

printf "${AMBRE}
Vous ne le savez peut-etre pas encore,  mais  la  grande
particularite de $BBS_NAME est d'etre accessible par des
outils   utlises   sur   Internet,    comme    Netscape,
Internet-exploreur,  Eudora,   FreeAgent,  Waffle  (sous
dos)...

Ces programmes permetent de decouvrir l'essemble du  BBS
de maniere plus intuitive ; puisque  qu'un  simple  clic
suffit pour naviguer a bord ! Cette acces se nomme  PPP.
Il est un standard pour sa simplicite et sa  portabilite
sur differents ordinateurs.

Toutes fois,  si  vous  souhaitez  posseder  une   telle
possibilite il vous suffit, tout simplement, d'ecrire un
message    de   presentation    dans    la    conference
'gyptis.presentation'. Ceci  aura  pour  effet  de  vous
valider automatiquement et de pourvoir naviger en toutes
simplicite!

Cependant  vous  pouvez  deja  telecharger  un  kit   de
connexion adapte a votre ordinateur ou  tout  simplement
le prendre lors de votre prochain passage.
 ${RESET}${QUESTION}
Desirez-vous le kit de connexion (O/n) ? : ${BLEU_PALE}";
    $choix = <STDIN>;
    chop($choix);

    $choix =~ tr/A-Z/a-z/;

    if ( $choix eq 'o' || !( ${choix} ) )
    {
       $PPP_OK=1;

       printf"$MESSAGE2 $CLS

${AMBRE}        -----------------$MESSAGE2

${GRAS}Cool!${MESSAGE2} voila notez bien ces indications pour l'acces PPP

          -> ${ROUGE}P%s${MESSAGE2}
            ou
          -> ${ROUGE}%s${MESSAGE2}  (si vous utilisez Windows95, ou FreePPP)

Il vous servira pour vous connecter sur Gyptis avec PPP! avec Windows95,
MacOs...

${AMBRE}        -----------------$MESSAGE2

", $login, $login;

        printf"

SVP: Appuyez sur ENTREE pour continuer.
";
        <STDIN>;

           if (&menu_kit == 2)
           {
              return 2;
           }
     }
      else
           {
              printf"

                     -----------------

Ok! Si vous changez d'avis n'oubliez pas, pour avoir l'acces PPP, de le
demander aux sysops !

                     -----------------
";
           }
} # acces_ppp

sub     recherche_login_old
{
        open(LINE, "$PASSWDFILE" );

        while ( <LINE> )
        {
                @tmp = split(/:/, $_);
                if ( $tmp[0] eq $login )
                {
                   #printf "$tmp[0]\n";
                        close(LINE);
                        return 1;
                }
                #printf "$tmp[0]\n";

        }
        close(LINE);
        0;
}

sub     recherche_pid
{
   $cpid = $STARPID;

   open(LINE, "$PASSWDFILE");
   while ( <LINE> )
   {
      @tmp = split(/:/);
      $var{$tmp[2]}++;
   }

   foreach $pid (sort(keys %var))
   {
      if ($pid == $cpid)
      {
         $cpid++;
      }
      $new_pid = $cpid;
      close(LINE);
   }
}


#  Adduser

sub     adduser
{
#
# Pour une utilisation avec Shadow utilisez la commande :
#
   if ($shadows)
   {
       $buf = sprintf "useradd  -u %s -d %s -G %s -s %s %s",
                     $pid, $home, $GROUP, $SHELL, $login;
       system "$buf";
       $buf = sprintf "useradd  -u P%s -d %s -G %s -s %s %s",
                     $pid, $home, $GROUP, $SHELL, $login;
       system "$buf";
       printf"Acces PPP etablit sous le login : P%s .\n", $login;
       sleep 1;
       open(OUT, ">>" . "$PASSWDFILE");
       printf OUT "%s:%s:%s:%s:%s,%s:%s:%s\n", $login,
                crypt($verifpass, $salt), $pid, $GROUP, $nom, $departement, $home,
       close(OUT);
   }
    else
    {
        recherche_pid();

        if ($new_pid >= 32767)
        {
           printf"Desole y a plus de place sur le BBS !

Sans blague, parlez-en avec le sysop en utilisant
le compte guest ou laisser un Mmessage

${QUESTION}Voulez-vous laisser un Message ou utiliser
le compte guest (M/c) ? : ${BLEU_PALE}";

           $choix = <STDIN>;
           $choix =~ tr/A-Z/a-z/;
           if ($choix eq "m")
           {
              system("$MAIL sysop");
           }
           system("su -l guest");
           return(1);
        }

        $home = $BLEUBIT . "/" . $login;
        $pid  = $new_pid;

        system("(cp \"%s\" \"%s.OLD\")", $PASSWDFILE, $PASSWDFILE);

        open(OUT, ">>" . "$PASSWDFILE");

###############################
#  Creation du compte "login" #
###############################

        printf OUT "%s:%s:%s:%s:%s,%s:%s:%s\n", $login,
                crypt($verifpass, $salt), $pid, $GROUP, $nom, $departement, $home,
$SHELL;
        printf"${RESET}Compte Terminal Cree.\n";
        sleep 1;

#  Creation du compte PPP
#if PPP
        if (PPP_OK)
        {
            printf OUT "P%s:%s:%s:%s:%s,%s:%s:%s\n", $login,
               crypt($verifpass, $salt), $pid, $GROUP, $nom, $departement,
               $home, ${SHELLPPP};
            printf"Acces PPP etablit sous le login : P%s .\n", $login;
            sleep 1;
        }
#endif /* PPP */

        close(<OUT>);
    } # if Shawdows

##########################
# Installation du compte #
##########################

        $buf = sprintf "( mkdir -p \"%s\")", $BLEUBIT;
        system "$buf";
        $buf = sprintf "( cd /etc/skel ; cp -a . \"%s\")", $home;
        system "$buf";
        $buf = sprintf "(chown -R %s.%s %s)", $login, $GROUP, $home;
        system "$buf";

        printf"Creation de votre repertoire personnel ($home)\n";
        sleep(2);
}

sub HTML_add_user
{

  open(LINE, "$PAGE_USER");
  open(LOUT, ">" . "${PAGE_USER}.old");

  while (<LINE>)
  {
     $nia = $_;

     printf LOUT "%s", $nia;

     if ( /${HTML_mots_clef}/ )
     {
        printf LOUT "<P><A HREF=\"/~${login}\">$nom</A></P>
";
     }
  }
  close(LINE);
  close(LOUT);

  $buf = sprintf "cp %s.old %s", ${PAGE_USER}, ${PAGE_USER};
  system $buf;

  if ($HTML_add_page_user)
  {
  # Ajout de la page HTML de l'utilisateur, bien formate :)

     $buf = sprintf "add_page_user %s %s %s", ${login}, ${nom}, $prenom;
     system $buf;
  }
}


1;
